#define tilesX 4
#define tilesY 4
#define numFrames 4
#define totalTiles 64


struct AnimatedBG{
	u8 delay;
	u8 speed;
	u16 start;
	u16 end;

	Fondo fondo;


	//u8 buffer[64];
	//u32 direccion;

	AnimatedBG();
	AnimatedBG(Fondo f);
	//AnimatedBG(Fondo f, u16 ini, u16 fin);

	void animar();

	//void iniciaBuffer();
	//void animar2();


};

AnimatedBG::AnimatedBG(){
	delay = 10;
	speed = 0;
	start = 1;
	end = start + totalTiles - 1;
}

AnimatedBG::AnimatedBG(Fondo f){
	delay = 10;
	speed = 0;
	start = 1;
	end = start + totalTiles - 1;

	this->fondo = f;
}


void AnimatedBG::animar(){
	u16 tileAct;
	u16 tile;

	speed++;
	if (speed >= delay){
		speed = 0;
		for (int i=0;i<fondo.ancho>>3;i++){
			for (int j=0;j<fondo.alto>>3;j++){
				tileAct = NF_GetTileOfMap(fondo.pantalla,fondo.capa,i,j);
				tile = tileAct - start;
				if ((tile >=0) && (tile <= end - start)){
					tile = (tile + tilesX * tilesY) % totalTiles;
					NF_SetTileOfMap(fondo.pantalla,fondo.capa,i,j,tile + start);
				}
			}
		}
		NF_UpdateVramMap(fondo.pantalla, fondo.capa);
	}
}

//AnimatedBG::AnimatedBG(Fondo f, u16 ini, u16 fin){
//	delay = 10;
//	speed = 0;
//	start = ini;
//	end = fin;
//	this->fondo = f;
//	iniciaBuffer();
//}
//
//void AnimatedBG::iniciaBuffer(){
//	u8 basetiles = NF_TILEDBG_LAYERS[fondo.pantalla][fondo.capa].tilebase;		// Base del Tileset
//	//u8 tileblocks = NF_TILEDBG_LAYERS[fondo.pantalla][fondo.capa].tileblocks;
//
//	if (fondo.pantalla == 0) {	// (VRAM_A)
//		direccion = (0x6000000) + (basetiles << 14);
//	} else {			// (VRAM_C)
//		direccion = (0x6200000) + (basetiles << 14);
//	}
//
//	memcpy(buffer,(void*)direccion,totalTiles);
//}
//
//void AnimatedBG::animar2(){
//	u16 tileAct;
//	u16 tile;
//	
//	u8 tmp[16];
//	u8 screen = fondo.pantalla;
//	u8 layer = fondo.capa;
//
//	speed++;
//	if (speed >= delay){
//		speed = 0;
//		
//		u8 slot = NF_TILEDBG_LAYERS[screen][layer].bgslot;
//		u8 basetiles = NF_TILEDBG_LAYERS[screen][layer].tilebase;				// Base del Tileset
//		u8 tilesblocks = NF_TILEDBG_LAYERS[screen][layer].tileblocks;			// Bloques usados por el Tileset
//
//		char msg2[128];
//		char *p;
//		
//		p = NF_BUFFER_BGTILES[slot];
//		u8 ini = 0;
//		for (int i=ini; i<ini+8;i++){
//			sprintf(msg2,"%c%c%c%c%c%c%c%c",p[(i-1)*8+1]+48,p[(i-1)*8+2]+48,p[(i-1)*8+3]+48,p[(i-1)*8+4]+48,p[(i-1)*8+5]+48,p[(i-1)*8+6]+48,p[(i-1)*8+7]+48,p[(i-1)*8+8]+48);
//			escribeDepurando(msg2, i - ini);
//		}
//
//
//
//		//memcpy(tmp,buffer,16);
//		//memcpy(buffer,&buffer[16],48);
//		//memcpy(&buffer[48],tmp,16);
//
//		//u8 basetiles = NF_TILEDBG_LAYERS[fondo.pantalla][fondo.capa].tilebase;		// Base del Tileset
//		/*u8 tilesize = NF_TILEDBG_LAYERS[fondo.pantalla][fondo.capa].tileblocks;
//		u32 adress = NF_GetTileMapAdress(fondo.pantalla,fondo.capa,1,0);
//
//		memset((void*)adress, 0, tilesize);*/
//
//		//u8 basemap = NF_TILEDBG_LAYERS[fondo.pantalla][fondo.capa].mapbase;
//		//u8 mapsize = (NF_TILEDBG_LAYERS[fondo.pantalla][fondo.capa].mapblocks << 11);
//		//if (fondo.pantalla == 0) {	// (VRAM_A)
//		//	adress = (0x6000000) + (basemap << 11);
//		//} else {			// (VRAM_C)
//		//	adress = (0x6200000) + (basemap << 11);
//		//}
//		//memset((void*)adress, 0, mapsize);		// Pon a 0 todos los bytes de la area de VRAM
//
//		//memcpy((void*)direccion,buffer,64);
//		//NF_UpdateVramMap(fondo.pantalla, fondo.capa);
//	}
//}
