
struct elementoU8{
	u8 valor;
	elementoU8 *anterior;

	elementoU8();
};

elementoU8::elementoU8(){
	valor = 0;
	anterior = NULL;
}

struct pilaU8{
	int tam;
	elementoU8 *ultimo;

	void add(u8 v);
	u8 getUltimo();
	void deleteUltimo();
	void clear();

	pilaU8();
};

pilaU8::pilaU8(){
	tam = 0;
	ultimo = NULL;
}

void pilaU8::add(u8 v){
	elementoU8 *e = new elementoU8();
	e->valor = v;
	e->anterior = ultimo;
	ultimo = e;
	tam++;
}

u8 pilaU8::getUltimo(){
	u8 v=0;
	if (ultimo != NULL)
		v = ultimo->valor;
	return v; 
}

void pilaU8::deleteUltimo(){
	elementoU8 *e;
	if (ultimo != NULL){
		e = ultimo;
		ultimo = ultimo->anterior;
		free(e);
		tam--;
	}
}

void pilaU8::clear(){
	elementoU8 *e;
	while (ultimo != NULL){
		e = ultimo;
		ultimo = ultimo->anterior;
		free(e);
		tam--;
	}
}