void InicializaCapaTexto(){
	NF_InitTextSys(inferior);
	PJ_LoadTextFont("fonts/fuente", "fuente3", 256, 256, 0);
	NF_CreateTextLayer(inferior, cTecho, 0, "fuente3");
}

void escribeConversacion(char *m){
	//PJ_WriteText(superior, cTecho, 0, 20,m);
	//NF_UpdateTextLayers();
}


void iniciaConversacionCon(char *msg){
	textX = empiezaTextoX;
	textY = empiezaTextoY;

	caracteresLeidos = 0;
	momentoActualEsc = 0;
	PJ_EscribeConversacion(inferior,cTecho,msg);
}

bool continuaConversacionCon(){

	if ((keydown.a) || (keydown.b) || (keyheld.a) || (keyheld.b))
		velEscritura = 1;
	else
		velEscritura = 10;

	momentoActualEsc = (momentoActualEsc + 1) % velEscritura;

	if (momentoActualEsc == 0){
		if (caracteresLeidos < spriteHablando->tamMensaje){
			PJ_EscribeConversacion(inferior,cTecho,spriteHablando->mensaje);
			return true;
		}else{
			if ((keydown.a) || (keydown.b)){
				NF_ClearTextLayer(inferior,cTecho);
				return false;
			}
			else
				return true;
		}
	}else{
		if (caracteresLeidos >= spriteHablando->tamMensaje){
			if ((keydown.a) || (keydown.b)){
				NF_ClearTextLayer(inferior,cTecho);
				return false;
			}
		}
		return true;
	}
}



bool puedeHablarCon(Sprite yo, Sprite otro){
	Sprite Iam,other;
	int x=0,y=0;
	if (yo.tieneAsociado)
		Iam = *yo.asociado;
	else
		Iam = yo;

	if (otro.tieneAsociado)
		other = *otro.asociado;
	else
		other = otro;

	switch (Iam.mira){
		case arriba:
			x = Iam.posXPantalla;
			y = Iam.posYPantalla - 32;
			break;
		case abajo:
			x = Iam.posXPantalla;
			y = Iam.posYPantalla + 32;
			break;
		case izquierda:
			x = Iam.posXPantalla - 32;
			y = Iam.posYPantalla;
			break;
		case derecha:
			x = Iam.posXPantalla + 32;
			y = Iam.posYPantalla;
			break;
		default:
			break;
	}

	return ((other.posXPantalla == x) && (other.posYPantalla == y));
}

bool compruebaHablar(){
	bool hablando = false;
	if (keydown.a){
		if (puedeHablarCon(s1,gato)){
			iniciaConversacionCon(gato.mensaje);
			spriteHablando = &gato;
			hablando = true;
		}
	}
	return hablando;
}