

void ocuparSpriteMapaColision(Sprite s, int mapa){
	int x,y;
	Sprite sp1;

	if (s.tieneAsociado)
		sp1 = *s.asociado;
	else
		sp1 = s;

	x = sp1.posXMapa;
	y = sp1.posYMapa - defTiles;

	NF_SetTile(mapa,x + 8,y + 8,tNPC);
}

void ocuparSpriteMapaColision(Sprite s,Direccion d, int mapa){
	int x,y;
	Sprite sp1;
	if (s.tieneAsociado)
		sp1 = *s.asociado;
	else
		sp1 = s;
	
	x = sp1.posXMapa;
	y = sp1.posYMapa - defTiles;

	switch (d){
		case arriba:
			y -= 32;
			break;
		case abajo:
			y += 32;
			break;
		case derecha:
			x += 32;
			break;
		case izquierda:
			x -= 32;
			break;
		default:
			break;
	}

	NF_SetTile(mapa,x + 8,y + 8,tNPC);
}

void liberarSpriteMapaColision(Sprite s, int mapa){
	int valor;
	int x,y;
	Sprite sp1;

	if (s.tieneAsociado)
		sp1 = *s.asociado;
	else
		sp1 = s;

	x = sp1.posXMapa;
	y = sp1.posYMapa - defTiles;
	valor = NF_GetTile(mapa,x+16,y+8);
	NF_SetTile(mapa,x + 8,y + 8,valor);
}
int tmp = 0;
void registraMovimiento(){

	if(s1.movimiento.tam == 0){
		if (keydown.up)
			tiempoPulsado.Arriba = 0;
		else if (keyup.up){
			if (tiempoPulsado.Arriba <= PULSO)
				s1.mirar(arriba,true);
		}else if (keyheld.up){
			tiempoPulsado.Arriba++;
			if (tiempoPulsado.Arriba > PULSO)
				s1.movimiento.add(arriba);
		}else if (keydown.down)
			tiempoPulsado.Abajo = 0;
		else if (keyup.down){
			if (tiempoPulsado.Abajo <= PULSO)
				s1.mirar(abajo,true);
		}else if (keyheld.down){
			tiempoPulsado.Abajo++;
			if (tiempoPulsado.Abajo > PULSO)
				s1.movimiento.add(abajo);
		}else if (keydown.left)
			tiempoPulsado.Izquierda = 0;
		else if (keyup.left){
			if (tiempoPulsado.Izquierda <= PULSO)
				s1.mirar(izquierda,true);
		}else if (keyheld.left){
			tiempoPulsado.Izquierda++;
			if (tiempoPulsado.Izquierda > PULSO)
				s1.movimiento.add(izquierda);
		}else if (keydown.right)
			tiempoPulsado.Derecha = 0;
		else if (keyup.right){
			if (tiempoPulsado.Derecha <= PULSO)
				s1.mirar(derecha,true);
		}else if (keyheld.right){
			tiempoPulsado.Derecha++;
			if (tiempoPulsado.Derecha > PULSO)
				s1.movimiento.add(derecha);
		}
	}
}



void realizaMovimiento(Direccion d){
	if (d != ninguna){
		s1.animar(d);
		if (s1.movimiento.paso == 1){
			s1.movimiento.bloqueado = !s1.puedeMover(d,0);
		}
		if (!s1.movimiento.bloqueado){
			gato.arrastrar(d,s1.velocidad);
			if (s1.movimiento.paso == 1){
				liberarSpriteMapaColision(s1,0);
				ocuparSpriteMapaColision(s1,d,0);
			}
		}
	}
}

void mueveGato(){

	Direccion d = gato.movimiento.getActualN(32);
	if (d != ninguna){
		gato.animar(d);
		if (gato.movimiento.paso == 1){
			gato.movimiento.bloqueado = !gato.puedeMover(d,0);
		}
		if (!gato.movimiento.bloqueado){
			if (gato.movimiento.paso == 1){
				liberarSpriteMapaColision(gato,0);
				ocuparSpriteMapaColision(gato,d,0);
			}
			gato.mover(d);
		}
	}
}

void moverMapa(Direccion d, Sprite s){
	
	if (d != ninguna){
		if (!s1.movimiento.bloqueado){
			
			f1.mover(d,s.velocidad);
			f2.mover(d,s.velocidad);
			f3.mover(d,s.velocidad);
			
			MapaX = f1.posX;
			MapaY = f1.posY;
			s1.actualizaPosicionMapa(MapaX,MapaY);
		}
	}
}