void iniciaSpriteSinDependencia(){
	gato.ancho = 32;
	gato.alto = 32;
	gato.anchoReal = 32;
	gato.altoReal = 32;
	gato.pantalla = inferior;
	gato.velAnimacion = 8;
	gato.velocidad = 1;
	strcpy(gato.ruta,"sprite/gato");
	strcpy(gato.paleta,"sprite/paleta");
	gato.movimiento.add(ninguna);
	gato.movimiento.add(derecha);
	gato.movimiento.add(ninguna);
	gato.movimiento.add(arriba);
	gato.movimiento.add(ninguna);
	gato.movimiento.add(izquierda);
	gato.movimiento.add(ninguna);
	gato.movimiento.add(abajo);
	gato.cambiaTexto((char*)"Llamame seor gato, [c=123110]gato con [grande]botas[/grande][/c]para los amigos");


}
void pruebaSpriteSinDependencia(){
	gato.cargaPaletaRAM(0);
	gato.cargarPaletaVRAM(0);
	gato.cargarRAM(2);
	gato.cargarVRAM(2, true);
	//gato.idVRAM = 1;
	gato.crear(2,224,128,false, arriba);
	gato.setCapa((Capa)3);

}

void iniciaSpriteConDependencia(){
	s2.ancho = 32;
	s2.alto = 32;
	s2.anchoReal = 28;
	s2.altoReal = 11;
	s2.pantalla = inferior;
	s2.velAnimacion = 4;
	s2.velocidad = 2;
	strcpy(s2.ruta,"sprite/protaP");
	strcpy(s2.paleta,"sprite/paleta");


	s1.ancho = 32;
	s1.alto = 32;
	s1.anchoReal = 28;
	s1.altoReal = 32;
	s1.pantalla = inferior;
	s1.velAnimacion = 8;
	s1.velocidad = 1;
	strcpy(s1.ruta,"sprite/protaC");
	strcpy(s1.paleta,"sprite/paleta");
	s1.tieneAsociado = true;
	s1.asociado = &s2;
}
void pruebaSpriteConDependencia(){
	
	s1.cargaPaletaRAM(0);
	s1.cargarPaletaVRAM(0);
	s1.cargarRAM(0,1);
	s1.cargarVRAM(0,1, true);
	s1.crear(0,1,112,64,true, derecha);
	s1.setCapa((Capa)2, (Capa)3);
}
void iniciaFondo(){
	strcpy(f1.ruta, "bg/mallada");
	strcpy(f1.nombre, "fondo");
	f1.alto = 512;
	f1.ancho = 1024;
	f1.pantalla = inferior;
	f1.capa = cSuelo;
	f1.posX = 48;
	f1.posY = 64;
	f1.defTiles = 32;
	f1.margenX = 16;
	NF_LoadColisionMap("colision/MAPA1C", 0, 1024, 512);
	MapaX = 48;
	MapaY = 64;
}

void iniciaFondos(){
	strcpy(f1.ruta, "bg/mapa1Suelo");
	strcpy(f1.nombre, "mapa1Suelo");
	f1.alto = 512;
	f1.ancho = 1024;
	f1.pantalla = inferior;
	f1.capa = cSuelo;
	f1.posX = 48;
	f1.posY = 64;
	f1.defTiles = 0;
	f1.margenX = 16;

	strcpy(f2.ruta, "bg/mapa1AguaAnim");
	strcpy(f2.nombre, "mapa1Agua");
	f2.alto = 512;
	f2.ancho = 1024;
	f2.pantalla = inferior;
	f2.capa = cAgua;
	f2.defTiles = 8;
	f2.posX = 48;
	f2.posY = 64 + f2.defTiles;
	f2.margenX = 16;

	strcpy(f3.ruta, "bg/mapa1Techo");
	strcpy(f3.nombre, "mapa1Techo");
	f3.alto = 512;
	f3.ancho = 1024;
	f3.pantalla = inferior;
	f3.capa = cTecho;
	f3.posX = 48;
	f3.posY = 64;
	f3.defTiles = 0;
	f3.margenX = 16;


	NF_LoadColisionMap("colision/mapa1Colision", 0, 1024, 512);
	MapaX = 48;
	MapaY = 64;
}


void cargaFondo(){
	f1.cargarRAM();
	f1.cargarVRAM();
}

void cargaFondos(){
	f1.cargarRAM();
	f1.cargarVRAM();
	f2.cargarRAM();
	f2.cargarVRAM();
	f3.cargarRAM();
	f3.cargarVRAM();
}